import { FormBuilder, FormControl } from '@angular/forms';
import { map, reduce } from 'lodash/fp';

const fb = new FormBuilder();

// Add name if missing
const addNameIfMissing = (val, key) => val.name ? val : Object.assign(val, { name: key });
// TODO


// Build Form Control
// metaF = metadata for Field
const buildControlState = metaF => ({ value: metaF.value || '', disabled: metaF.isDisabled });
const buildValidators = metaF => ({
	validators: null,
	asyncValidators: null,
	updateOn: 'blur'
});
const buildFormControl = metaF => new FormControl(buildControlState(metaF) /*, buildValidators(metaF) */);

// Build Form Group Member
// metaFoG = metadata for Field Or Group
const isGroup = metaFoG => metaFoG.meta && !metaFoG._field;
const buildFormGroupMember = metaFoG => isGroup(metaFoG) ? buildFormGroup(metaFoG.meta) : buildFormControl(metaFoG);

// metaG = metadata for Group - possibly nested
const buildFormGroupReducerIteree = (res, metaFoG) => Object.assign(res, { [metaFoG.name]: buildFormGroupMember(metaFoG) });
const buildFormGroup = metaG => fb.group(reduce(buildFormGroupReducerIteree, {}, metaG));

// ---------------------------------------------------------------------------------------------------------------------
// Exports

export { buildFormGroup };




